#!/bin/bash

set -ex

# $1 : local path to binary
# $2 : binary
# $3 : serial device


BAUD=115200
DATARATE=1000000
MINICOM_CFG=5:0:1cb2:0:3:1c:7f:15:4:2:0:0:11:13:1a:0:12:f:17:16:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0

if [ $# -ne 3 ]
then
        echo "$0: path file serial device"
else
        /bin/ls -l "$1$2"  > /tmp/IDD$$
        BYTE=`awk '{ print $5 }' /tmp/IDD$$`
        BIT=`echo $(($BYTE*10))`
        SEC=`echo $(($BIT/$BAUD))`

	if [ $SEC -gt 255 ]
	then
		SEC=255
	fi

	/bin/rm -f /tmp/IDD$$
        
	exit $SEC
fi
