#!/bin/bash

set -ex

# $1 : serial device
# $2 : binary



if [ $# -ne 2 ]
then
	echo "$0: tty file"
else

	# Need to stop before changing firmware name...
	###
	{
	echo -e "echo stop > /sys/class/remoteproc/remoteproc0/state" 
	/bin/sleep 1
	} > "$1"

		/bin/rm -f state
		#echo -e "sz -a /sys/class/remoteproc/remoteproc0/state > /dev/tty < /dev/tty" > "$1" 
		#/usr/bin/rz --zmodem > "$1" < "$1" 
		#echo $?
		#STATE=`cat state`

	# Updating firmware
	###

	# 32 char max sent on the terminal: 32 - 17 (cmd) -4 (ext) = 11 char max for project name !! 
	# todo: investigate

	{
	echo -e "echo \"$2\" > /sys/class/remoteproc/remoteproc0/firmware" 
	/bin/sleep 1
	} > "$1"

		/bin/rm -f firmware 
		#echo -e "sz -a /sys/class/remoteproc/remoteproc0/firmware > /dev/tty < /dev/tty" > "$1" 
		#/usr/bin/rz --zmodem > "$1" < "$1"
		#echo $?
		#REMOTE_FIRMWARE=`cat firmware`

	# Starting it with check of result ... 
	###
	{
		echo -e "echo start > /sys/class/remoteproc/remoteproc0/state" 
		/bin/sleep 1
	} > "$1"

		#/bin/rm -f state

		#echo -e "sz -a /sys/class/remoteproc/remoteproc0/state > /dev/tty < /dev/tty" > "$1" 
		#/usr/bin/rz --zmodem > "$1" < "$1"
		#echo $?
#		/bin/sleep 1
		
		#STATE=`cat state`
		#if [ $STATE == "offline" ]
		#then
			RET=128
		#fi
		#if [ $STATE == "running" ]
		#then
			RET=0
		#fi


#	if [ $RET == 128 ]
#	then
#		Start  "$1"
#	fi

	exit $RET
fi